// File: uMain.pas
// Date: 19.11.2012

unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Winsock2;


resourcestring
  RES_UNKNOWN = '';

const
  WSA_TYPE = $202;
  TEST_ADDRESS = '192.168.146.1';
  BEGIN_LABEL = ' : ';

type
  TMainForm = class(TForm)
    btRun: TButton;
    lbCompName: TLabel;
    procedure btRunClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}


function GetCompName(const Addr: Integer): String;
var
  WSA: TWSAData;
  Host: PHostEnt;
  Err: Integer;
begin
  Result := RES_UNKNOWN;
  Err := WSAStartup(WSA_TYPE, WSA);

  if Err <> 0 then  //    ,
  begin             //         .
    //ShowMessage(SysErrorMessage(GetLastError));
    Exit;
  end;

  try
    if Addr = INADDR_NONE then Exit;

    Host := GetHostByAddr(@Addr, SizeOf(Addr), PF_INET);

    if Assigned(Host) then  //  ,   , 
      //Result := PChar(WideChar(Host.h_name)) //     IP,  AV  ---     
      Result := PChar(WideString(AnsiString(Host.h_name))) //     IP,  AV
    else
      //ShowMessage(SysErrorMessage(GetLastError));
  finally
    WSACleanup;
  end;

end;


procedure TMainForm.btRunClick(Sender: TObject);
var
  sCurAddress, CompName: String;
  IP: Integer;

begin
  IP := inet_addr(PAnsiChar(AnsiString(TEST_ADDRESS)));
  CompName := GetCompName(IP);

  lbCompName.Caption := BEGIN_LABEL + CompName;
end;

end.
